import type { Window, Dependencies, Dispatcher } from '@ima/core';
import { ResourceLoader } from '@ima/plugin-resource-loader';
/**
 * Script loader plugin class.
 */
export declare class ScriptLoader {
    _window: Window;
    _dispatcher: Dispatcher;
    _resourceLoader: ResourceLoader;
    _loadedScripts: Record<string, Promise<void | {
        url: string;
    }>>;
    static get $dependencies(): Dependencies;
    constructor(window: Window, dispatcher: Dispatcher, resourceLoader: ResourceLoader);
    /**
     * Load third party script to page.
     *
     * @param url
     * @param template
     * @param force
     * @returns {Promise<{url: string}>}
     */
    load(url: string, template?: string, force?: boolean): Promise<void | {
        url: string;
    }> | undefined;
    /**
     * Creates a new script element and returns it.
     *
     * @returns The created script element.
     */
    _createScriptElement(): HTMLScriptElement;
    /**
     * Handle on load event for script. Resolve load promise and fire LOADED
     * events.
     * @param url
     */
    _handleOnLoad(url: string): {
        url: string;
    };
    /**
     * Handle on error event for script. Reject load promise and fire LOADED
     * events.
     *
     * @param url
     * @throws Error
     */
    _handleOnError(url: string): void;
}
//# sourceMappingURL=ScriptLoader.d.ts.map